using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/*
Primary Objects Linquify - Business Class Generator
Copyright (C) 2010 Kory Becker
http://www.primaryobjects.com

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.
*/

namespace BingMapTest.Types.GeneratedTypes
{
    [Serializable]
    public partial class location : BingMapTest.Types.GeneratedTypes.BaseTypes.location
    {
		public location()
		{
		}

		public location(BingMapTest.Types.GeneratedTypes.BaseTypes.location location)
		{
			LocationId = location.LocationId;
			CreateDate = location.CreateDate;
			Description = location.Description;
			Latitude = location.Latitude;
			Longitude = location.Longitude;
			Title = location.Title;

			OnInitializeComplete();
		}
		
        public location(System.Nullable<int> _LocationId, global::System.Nullable<global::System.DateTime> _CreateDate, string _Description, double _Latitude, double _Longitude, string _Title)
        {
            if (_LocationId != null)
            {
                LocationId = (int)_LocationId;
            }

			CreateDate = _CreateDate;
			Description = _Description;
			Latitude = _Latitude;
			Longitude = _Longitude;
			Title = _Title;

        }

        public new List<location> Find()
        {
            List<location> finalResults = new List<location>();

            List<BingMapTest.Types.GeneratedTypes.BaseTypes.location> results = base.Find();

            return ConvertFromBaseTypes(results);
        }		

        public new List<location> ToList()
        {
            List<location> finalResults = new List<location>();

            List<BingMapTest.Types.GeneratedTypes.BaseTypes.location> results = base.ToList();

            return ConvertFromBaseTypes(results);
        }
        
        private List<location> ConvertFromBaseTypes(List<BingMapTest.Types.GeneratedTypes.BaseTypes.location> baseTypeList)
        {
			List<location> typeList = new List<location>();
			
            foreach (BingMapTest.Types.GeneratedTypes.BaseTypes.location baseType in baseTypeList)
            {
                typeList.Add(new location(baseType));
            }
            
            return typeList;
        }
    }
}
